 '===================================================='
 ' objective is to move from memory to code all strings in B4R project
 ' 2 way managed:
 '   - move to code with PROGMEM all strings from memory
 '   - move back strings from PROGMEM to memory
 '====================================================='
 option explicit
 const module_name  = "B4R_PROGMEM"           'this name must be unique !!!
 const module_desc  = "B4R PROGMEM management"  'script description
 const module_ver   = "0.002"                 'version  du 25/07/2020

 public mychaine, myarray, myfilename, fname, fnb, fi, flength ,l_max ,err
 public obj1, obj2, s ,linemax , wshshell, btncode                 'variable definition

 '===============================================' 
 'not used
 '===============================================' 
 sub Main 
 end sub

'==============================================' 
'PROGMEM create
'==============================================' 
' move of some string to PROGMEM'
' some tags '<str1> '<str2> '<str3> '<str4> '<str5>  are checked on each line and if found, we check if a string is found, and if yes,it is moved to PROGMEM part, PROGMEM part is created
sub progmemCreate
   dim i, j, F_tag, P_tag, l_max, myline, myline2, myline3, l_p1, l_p2, l_p3,mystr, mychain, PstrNb, Pstrlength, Pstr, Pstrx, mycomment, x, y,z,nbspace    
   logclear  
                                                            
   'main procedure  creation of a B4X.cpp file from h file arduino 
   set obj1 = NewEditor()           'new editor object
   set obj2 = NewEditor()           'new editor object   
   obj1.assignActiveEditor         'assign PSPad window active to obj1
      obj2.NewFile()      
   mychain = obj1.text
   if instr(mychain,"'<str1>") > 0 then y =1                    'check of tables to create
   if instr(mychain,"'<str2>") > 0 then y =y+2
   if instr(mychain,"'<str3>") > 0 then y =y+4
   if instr(mychain,"'<str4>") > 0 then y =y+8
   if instr(mychain,"'<str5>") > 0 then y =y+16   
   if instr(mychain,"'<str6>") > 0 then y =y+32                    'check of tables to create
   if instr(mychain,"'<str7>") > 0 then y =y+64
   if instr(mychain,"'<str8>") > 0 then y =y+128
   if instr(mychain,"'<str9>") > 0 then y =y+256
   if instr(mychain,"'<str10>") > 0 then y =y+512   
   if instr(mychain,"'<str11>") > 0 then y =y+1024                    'check of tables to create
   if instr(mychain,"'<str12>") > 0 then y =y+2048
   if instr(mychain,"'<str13>") > 0 then y =y+4096
   if instr(mychain,"'<str14>") > 0 then y =y+8192
   if instr(mychain,"'<str15>") > 0 then y =y+16384        
''   logaddline(y)    
   Call addinlineheader(y)                                    'add the part fixe '

     mychain = replace(mychain,chr(13),"")
     mychain = replace(mychain,chr(09),"    ")
     myarray = split(mychain,chr(10))
     l_max = ubound(myarray)
      
   x = Array("str1","str2","str3","str4","str5","str6","str7","str8","str9","str10","str11","str12","str13","str14","str15") :Pstrlength=0 : mychain = "" :z =0  
   for each P_tag in x
     F_tag ="<"+P_tag+">"
     if (y and 2^z) <1  then 
       logaddline("no tag "+F_tag+"  => no PROGMEM to add")
     else
       logaddline("       "+F_tag+"  => found")

       PstrNb=0 :Pstr="": Pstrx ="const char* const "+P_tag+"_table[] PROGMEM  = {"
       for j = 0 to l_max
         myline = Rtrim(myarray(j))
         l_p1 = instr(myline,F_tag)
         if l_p1>0 then                                 'case flag found'
           mycomment= trim(mid(myline,l_p1))
           myline = Rtrim(left(myline, l_p1-1)) :myline2=myline:myline = myline+"    "+mycomment
           myline2 = replace(myline2,chr(34)+chr(34),"''")        'change "" to ''
           l_p1= instr(myline2,chr(34))                  'first "
           l_p2= instr(l_p1+1, myline2, chr(34))                 'second "
           if (l_p1=0 or l_p2=0) then 
             logaddline("line "+cstr(j)+"   error in string")
             myline = replace(myline,F_tag,F_tag+"   ===> error")
           else   
             mystr = mid(myline,l_p1, l_p2-l_p1+1)
             mystr=replace(mystr,chr(34)+chr(34),"\"+chr(34))              'to replace "" by \* 
             
             myline2 = rtrim(left(myline,l_p1-1)) : logaddline(myline2)
             l_p3 = instr(myline2,"(")            : logaddline(l_p3)
             if l_p3>0 then  myline2 = rtrim(left(myline2,l_p3-1))
             myline3 = ltrim(myline2): l_p3 = len(myline2)-len(myline3)
             
               myline = space(l_p3)+"P_get("+cstr(z+1)+","+cstr(PstrNb) +"):"+ myline3 +"1(P_buff)"+ mid(myline,l_p2+2)
''             else
''               myline = myline2 +" P_get("+cstr(z+1)+","+cstr(PstrNb) +") "+ mid(myline,l_p2+2)
''             end if 
              
             if (len(mystr) > Pstrlength) then Pstrlength = len(mystr)
             if (len(mystr)> 256) then 
               logaddline(mystr)
               logaddline("line="+cstr(j)+" len="+cstr(len(mystr))+"   ==> string to long")
               myline = replace(myline,F_tag,F_tag+" ====> "+cstr(len(mystr))+" string too long")
             end if
             mychaine = mychaine+"const char "+P_tag+"_"+cstr(PstrNb)+"[] PROGMEM = "+mystr+";"+chr(10)  
             if (Pstrnb = 0) then Pstrx = Pstrx + P_tag+"_"+cstr(Pstrnb)+" "  else Pstrx = Pstrx +","+P_tag+"_"+cstr(Pstrnb)+" "  
             PstrNb = PstrNb+1  
           end if             
         end if   
         myarray(j) = myline
''       mychain = mychain+myline+chr(10)
       next
       Pstrx = pstrx + "};"+chr(10)   
       mychaine = mychaine+chr(10)+ pstrx   +chr(10)
          
     end if
     z = z+1
   next
   mychain = join(myarray, chr(10)) 
   
   addinlinefooter(y)  
     
   mychain = replace(mychain,"Process_Globals","Process_Globals"+chr(10)+ "    Public P_buff() As byte")
   mychaine = replace(mychaine,"strx[xxxx];","strx["+cstr(Pstrlength+1)+"];") 
   mychaine = mychain+ mychaine 
 
   obj2.text (mychaine) 
end sub 

sub addinlineheader(nb)
   mychaine ="" +"'[added part]"+chr(10)
   mychaine=mychaine+"'******************************************************" +chr(10)
   mychaine=mychaine+"'inline C" +chr(10)
   mychaine=mychaine+"'****************************************************************" +chr(10)+chr(10)
   mychaine=mychaine+"Public Sub P_get(table as Byte, index As UInt)" + chr(10)
   mychaine=mychaine+" Select table" +chr(10)
   mychaine=mychaine+" Case 1" +chr(10)
   mychaine=mychaine+"   RunNative(""getdata1"" ,index)" +chr(10)
   if (nb and 2)>0 then 
     mychaine=mychaine+" Case 2" +chr(10)
     mychaine=mychaine+"   RunNative(""getdata2"" ,index)" +chr(10)
   end if  
   if (nb and 4)>0 then 
     mychaine=mychaine+" Case 3" +chr(10)
     mychaine=mychaine+"   RunNative(""getdata3"" ,index)" +chr(10)  
   end if 
   if (nb and 8)>0 then 
     mychaine=mychaine+" Case 4" +chr(10)
     mychaine=mychaine+"   RunNative(""getdata4"" ,index)" +chr(10) 
   end if
   if (nb and 16)>0 then 
     mychaine=mychaine+" Case 5" +chr(10)
     mychaine=mychaine+"   RunNative(""getdata5"" ,index)" +chr(10) 
   end if
   if (nb and 32)>0 then 
     mychaine=mychaine+" Case 6" +chr(10)
     mychaine=mychaine+"   RunNative(""getdata6"" ,index)" +chr(10)
   end if  
   if (nb and 64)>0 then 
     mychaine=mychaine+" Case 7" +chr(10)
     mychaine=mychaine+"   RunNative(""getdata7"" ,index)" +chr(10)  
   end if 
   if (nb and 128)>0 then 
     mychaine=mychaine+" Case 8" +chr(10)
     mychaine=mychaine+"   RunNative(""getdata8"" ,index)" +chr(10) 
   end if
   if (nb and 256)>0 then 
     mychaine=mychaine+" Case 9" +chr(10)
     mychaine=mychaine+"   RunNative(""getdata9"" ,index)" +chr(10) 
   end if   
   if (nb and 512)>0 then 
     mychaine=mychaine+" Case 10" +chr(10)
     mychaine=mychaine+"   RunNative(""getdata10"" ,index)" +chr(10) 
   end if
   if (nb and 1024)>0 then 
     mychaine=mychaine+" Case 11" +chr(10)
     mychaine=mychaine+"   RunNative(""getdata11"" ,index)" +chr(10)
   end if  
   if (nb and 2048)>0 then 
     mychaine=mychaine+" Case 12" +chr(10)
     mychaine=mychaine+"   RunNative(""getdata12"" ,index)" +chr(10)  
   end if 
   if (nb and 4096)>0 then 
     mychaine=mychaine+" Case 13" +chr(10)
     mychaine=mychaine+"   RunNative(""getdata13"" ,index)" +chr(10) 
   end if
   if (nb and 8192)>0 then 
     mychaine=mychaine+" Case 14" +chr(10)
     mychaine=mychaine+"   RunNative(""getdata14"" ,index)" +chr(10) 
   end if     
   if (nb and 16384)>0 then 
     mychaine=mychaine+" Case 15" +chr(10)
     mychaine=mychaine+"   RunNative(""getdata15"" ,index)" +chr(10) 
   end if 
         
   mychaine=mychaine+" Case Else" +chr(10)
   mychaine=mychaine+"   RunNative(""getdata1"" ,index)" +chr(10) 
   mychaine=mychaine+" End Select" +chr(10)    
   mychaine=mychaine+"End Sub" +chr(10)
   mychaine=mychaine+" " +chr(10)
   
   mychaine=mychaine+"#if C" +chr(10)
   mychaine=mychaine+"#include <avr/pgmspace.h> " +chr(10)
   mychaine=mychaine+"char strx[xxxx];" +chr(10) 
   mychaine=mychaine+" " +chr(10) 

end sub 


sub addonefooter(n)
   mychaine=mychaine+"B4R::Object* getdata"+n+"(B4R::Object* o) { "  +chr(10)        
   mychaine=mychaine+"    strcpy_P(strx, (char*)pgm_read_dword(&(str"+n+"_table[o->toLong()])));" +chr(10)
   mychaine=mychaine+"    b4r_main::_p_buff->data = strx; " +chr(10)
   mychaine=mychaine+"    int n=0;" +chr(10)
   mychaine=mychaine+"    do"  +chr(10)
   mychaine=mychaine+"      n++;" +chr(10)
   mychaine=mychaine+"    while (strx[n]!=0) ;" +chr(10)
   mychaine=mychaine+"    b4r_main::_p_buff->length = n; " +chr(10)
   mychaine=mychaine+"    return 0;"  +chr(10) 
   mychaine=mychaine+"}" +chr(10)
end sub
    

sub addinlinefooter(nb)    
   mychaine=mychaine+" " +chr(10)        
   mychaine=mychaine+"B4R::Object beo1;" +chr(10)
      
   addonefooter("1")
   if (nb and 2)>0 then addonefooter("2")   
   if (nb and 4)>0 then addonefooter("3")   
   if (nb and 8)>0 then addonefooter("4")
   if (nb and 16)>0 then addonefooter("5")
   if (nb and 32)>0 then addonefooter("6")
   if (nb and 64)>0 then addonefooter("7")
   if (nb and 128)>0 then addonefooter("8")
   if (nb and 256)>0 then addonefooter("9")
   if (nb and 512)>0 then addonefooter("10")
   if (nb and 1024)>0 then addonefooter("11")
   if (nb and 2048)>0 then addonefooter("12")
   if (nb and 4096)>0 then addonefooter("13")
   if (nb and 8192)>0 then addonefooter("14")
   if (nb and 16384)>0 then addonefooter("15")

   mychaine=mychaine+"#end if"   
   mychaine=mychaine+" " +chr(10)			
end sub
 
 
 
'==============================================' 
'PROGMEM remove
'==============================================' 
' remove of some string  from PROGMEM and move it back to standard code'
' function P_string() is checked on each line and if it is found, we take string corresponding in PROGMEM part and it replace getstring() fnction. PROGMEM part is removed
sub progmemRemove
   dim i, j,myarray2,l_max2, l_max, myline, mychain, l_p1, l_p2, mystr, mystr2, mystr3, mylink, mytab, myindex 
   logclear  
                                                            
   'main procedure  creation of a B4X.cpp file from h file arduino 
   set obj1 = NewEditor()           'new editor object
   set obj2 = NewEditor()           'new editor object   
   obj1.assignActiveEditor         'assign PSPad window active to obj1
      obj2.NewFile()      
   mychain = obj1.text
   l_p1= instr(mychain,"'[added part]")
   if l_p1 = 0 then  
     logaddline("first tag PROGMEM not found:  '[added part]")
     l_p1= instr(mychain,"public Sub P_string(")
   end if  
   if l_p1 = 0 then
     logaddline("second tag PROGMEM not found:  public Sub P_string(")
     exit sub
   end if
   mychaine = mid(mychain,l_p1)        ' all PROGMEM strings
   mychain = left(mychain,l_p1-1)        ' the B4R code
   
 
   
   mychaine = replace(mychaine,chr(13),"")
   mychaine = replace(mychaine,chr(09),"    ")
   myarray = split(mychaine,chr(10))
   l_max = ubound(myarray)
   mychain = replace(mychain,chr(13),"")
   mychain = replace(mychain,chr(09),"    ")
   myarray2 = split(mychain,chr(10))
   l_max2 = ubound(myarray2)

   for i = 0 to l_max
   myline = myarray(i)
   if len(trim(myline)) <> 0 then
     if instr(myline,"const char* const")=1 then
        logaddline("line const char*")
     else
       if instr(myline,"const char str") = 1 then
         l_p1 = instr(myline,"[] PROGMEM =")
         l_p2 = instr(myline,"_")
         if l_p1=0 or l_p2=0 or (l_p2>l_p1) then
           logaddline("error line"+ cstr(i))
         else   
           mystr = trim(mid(myline, l_p1+12)): mystr = left(mystr, len(mystr)-1) : mystr= replace(mystr,"\"+chr(34),chr(34)+chr(34))          '\" =>""
           mytab = mid(myline,15,l_p2-15)              'table nbr'
           myindex = mid(myline,l_p2+1,l_p1-l_p2-1)     'index nbr'
           mystr2 = "P_get("+mytab+","+myindex+"):"      'first case of link tp PROGMEM string
''           logaddline(mystr2+"---->"+mystr)
           if instr(mychain,mystr2) < 1 then 
             logaddline("string not found ====> "+mystr)                                 'logaddline("string not found ====> "+mystr2)
           else  
             for j = 0 to l_max2
                if instr(myarray2(j),mystr2) > 0 then
                   myarray2(j) = replace(myarray2(j),mystr2,"")
                   myarray2(j) = replace(myarray2(j),"1(P_buff","("+mystr)
                end if   
             next      
           end if         
         end if      
       end if 
     end if
   end if
   next
   mychain = join(myarray2,chr(10))  
   mychain = replace(mychain,chr(10),chr(13)+chr(10)) 
   mystr3 = "    Public P_buff() As Byte"+chr(13)+chr(10)
   if instr(mychain,mystr3) > 0 then
      mychain = replace(mychain,mystr3,"")
   else
      logaddline("String not found ====> "+mystr3)  
   end if 
   obj2.text (mychain)
   
end sub 




'==============================================' 
'PROGMEM lines extracted and cleaned to be ready to create several index.htm  files
'==============================================' 
' 1) remove all lines, except PROGMEM lines
' 2) clean each line to provide a file ready to be inegreted in several index.htm
' 3) you have just to copy each part of the file to create index.htm, style.css, etc...
sub progmemExtraxt
   dim i, j,myarray2,l_max2, l_max, myline, mychain, l_p1, l_p2, mystr, mystr2, mystr3, mylink, mytab, myindex 
   logclear  
                                                            
   'main procedure  creation of a B4X.cpp file from h file arduino 
   set obj1 = NewEditor()           'new editor object
   set obj2 = NewEditor()           'new editor object   
   obj1.assignActiveEditor         'assign PSPad window active to obj1
      obj2.NewFile()      
   mychaine = obj1.text
 
   
   mychaine = replace(mychaine,chr(13),"")
   mychaine = replace(mychaine,chr(09),"    ")
   myarray = split(mychaine,chr(10))
   l_max = ubound(myarray)
   
   for i = 0 to l_max
   myline = myarray(i)
   if len(trim(myline)) <> 0 then

     if instr(myline,"const char str")<1 then
        myarray(i)= ""
     else   'line PROGMEM'
       l_p1 = instr(myline,"[] PROGMEM =")
       myline = mid(myline,l_p1+14)
 ''               logaddline(myline)
       l_p2 = instrRev(myline,chr(34)+";")
       myline = left(myline,l_p2-1)
       myarray(i) = myline     
    end if 

   end if
   next
   
   mychaine = ""
   for j = 0 to l_max
     myline = trim(myarray(j))
     if  trim(myline) <> "" then
       if mychaine = "" then 
          mychaine = myarray(j)
       else
          mychaine = mychaine + chr(10)+ myarray(j)   
       end if
    end if                
  next
   mychaine = replace(mychaine,"/*","*")
   mychaine = replace(mychaine,chr(10),chr(13)+chr(10)) 
   obj2.text (mychaine)

end sub 








'==================================================' 
'TXT to PROGMEM  in Static.bas file
'==================================================' 
' open a text file and add content in string format in PROGMEM part
' at start, a file Static.bas must be created and PROGMEM data will be added at this one
' data are created by data1, data2, data3, etc....'
' a commun GETBYTE sub is created/modified to handle all data files from B4R
' an object is created to handle each data file at arduino level'
sub progmemaddtxt    
    Const ForReading = 1, ForWriting = 2, ForAppending = 8
   Dim fso, wshshell, strCurDir, f  ,l_array, l_chain1,l_chain2,l_max ,l_pos1,l_pos2 , l_p1,ts ,a , i ,j
   dim s_IniDir, s_Filter,chaine , path   
   
   s_IniDir = replace("D:\B4R\B4R_applis\testaWOT\text"+"\*","\","\\")       
   s_Filter = "texte file (*.txt)"
   set obj1 = NewEditor()           'new editor object
   set obj2 = NewEditor()
   obj1.assignActiveEditor         'assign PSPad window active to obj1   
   obj2.NewFile()      
    mychaine = obj1.text
    logclear
   mychaine = replace(mychaine,chr(13),"")
   mychaine = replace(mychaine,chr(09),"    ")
   
   path = replace(GetFileDlg(s_IniDir,s_Filter,"Select gzip file to add in PROGMEM"),chr(13)+chr(10),"")
   if path ="" then exit sub
   Set fso = CreateObject("Scripting.FileSystemObject")
''   Set f = fso.getFile(path)
   Set ts = fso.OpenTextFile(path)
''   logaddline("file size:"+ cstr(ts.size))
   i=0:j=0 : fname =  fso.getfilename(path)
   logaddline(fname)
 
   checkPROGMEMT: if err= 1 then exit sub   'test if PROGMEM still created / test witch getstring exist to select one not used'
    
   if fi=0 then 
      addprogmemT(ts) 
      addheaderT 
      addfooterT
   else
      insertprogmemT(ts)    
      insertheaderT
      insertfooterT
   end if  
''   mychaine = replace(mychaine, "#end if"+chr(10),"#end if"+chr(10)+cstr(flength) 
 obj2.text (mychaine)
 end sub

 '==================================================' 
 sub insertfooterT 
 logaddline("insertfooter text")
' after PROGMEM  
  dim av, ap
  
  ap =  "  B4R::Object* getstr"+cstr(fnb)+"(B4R::Object* o) { "  +chr(10)        
  ap = ap +"    strcpy_P(strx, (char*)pgm_read_dword(&(str"+cstr(fnb)+"_table[o->toLong()])));" +chr(10)
  ap = ap +"    b4r_P::_p_buff->data = strx; " +chr(10)
  ap = ap +"    int n=0;" +chr(10)
  ap = ap +"    do"  +chr(10)
  ap = ap +"      n++;" +chr(10)
  ap = ap +"    while (strx[n]!=0) ;" +chr(10)
  ap = ap +"    b4r_P::_p_buff->length = n; " +chr(10)
  ap = ap +"    return 0;"  +chr(10) 
  ap = ap +"  }" +chr(10)
  av = "#end if"+chr(10)
  if instr(mychaine,"#end if")>0 then
    mychaine = replace(mychaine,av, ap+av )
  else
    logaddline("no tag <#end if> ***error***")
  end if   
end sub

 '=================================================='  
sub insertheaderT
logaddline("insertheader text")
'before PROGMEM
   dim av, ap ,getstring ,i
   av = "  End Select"
   ap = "    Case "+cstr(fnb)+chr(10)
   ap = ap + "      RunNative(""getstr"+cstr(fnb)+" "" ,index)" +chr(10)  

   myarray = split(mychaine,chr(10)) 
   l_max = ubound(myarray)   
   for i = 0 to l_max                      
     if instr(myarray(i),"Public Sub Getstring")> 0 then getstring = 1
     if instr(myarray(i),"End Select")> 0 and getstring = 1 then
        myarray(i) = ap + av
        getstring = 0
        exit for
     end if
   next 
   if i >49 then logaddline("tag <    case else> not found ***error***")        
   mychaine = join(myarray,chr(10)) 

end sub

 '================================================== 
sub insertprogmemT(ts) 
logaddline("insertprogmem text")
   dim a, i, j, ap, av, str_t

   ap = ""
   j = 0 

   str_t = "const char* const str"+cstr(fnb)+"_table{] PROGMEM = {"
   While Not ts.atEndOfStream
      a = ts.ReadLine
      if len(a) > flength then flength = len(a)
      ap = ap + "const char str"+cstr(fnb)+"_"+cstr(j)+"[] PROGMEM = "+chr(34) + a + chr(34)+";"+chr(10)
      if j = 0 then
        str_t = str_t + "str"+cstr(fnb)+"_"+cstr(j)
      else
        str_t = str_t + " ,str"+cstr(fnb)+"_"+cstr(j)
      end if  
      j=j+1 
   wend
   ts.close
   str_t = str_t + " };"+chr(10)                                                              
   logaddline("end text=> PROGMEM add")
 
 'change length max of string in strx'  
   myarray = split(mychaine,chr(10))
   l_max = ubound(myarray)
   for i = 0 to l_max
      if instr(myarray(i),"char strx[")> 0 then
         myarray(i)="char strx["+cstr(flength)+"];"
         i = l_max+1
      end if    
   next
   mychaine = join(myarray,chr(10))  
''  add new strings in PROGMEM format  
   av = "B4R::Object beo1;"+chr(10) 
   if instr(mychaine,"B4R::Object beo1;")>0 then  
     mychaine = replace(mychaine,av,ap +chr(10) + str_t + chr(10)+av)
   else
     logaddline("no tag <B4R::Object beo1;>  ***error***")
   end if  
end sub


 '==================================================' 
 sub addfooterT 
 logaddline("addfooter text")
' after PROGMEM  
  dim av, ap
  if instr(mychaine,"B4R::Object beo1;")<1 then
    mychaine = mychaine + "B4R::Object beo1;"+chr(10)
  end if
  
  ap =  "  B4R::Object* getstr1(B4R::Object* o) { "  +chr(10)        
  ap = ap +"    strcpy_P(strx, (char*)pgm_read_dword(&(str1_table[o->toLong()])));" +chr(10)
  ap = ap +"    b4r_P::_p_buff->data = strx; " +chr(10)
  ap = ap +"    int n=0;" +chr(10)
  ap = ap +"    do"  +chr(10)
  ap = ap +"      n++;" +chr(10)
  ap = ap +"    while (strx[n]!=0) ;" +chr(10)
  ap = ap +"    b4r_P::_p_buff->length = n; " +chr(10)
  ap = ap +"    return 0;"  +chr(10) 
  ap = ap +"  }" +chr(10)
  av = "#end if"+chr(10)
  if instr(mychaine,"#end if")>0 then
    mychaine = replace(mychaine,av, ap+av )
  else
      logaddline("no tag <#end if> ***error***")  
  end if   
end sub

'=================================================='  
sub addheaderT
logaddline("addheader text")
   dim av, ap
   av = "#if C"+chr(10)
   ap = ap + "Public Sub Getstring(table as Byte, index As UInt)" + chr(10)
   ap = ap + "  Select Table" +chr(10)
   ap = ap + "    Case 1" +chr(10)
   ap = ap + "      RunNative(""getstr1"" ,index)" +chr(10)  
   ap = ap + "  End Select "+chr(10)
   ap = ap + "End Sub"+chr(10)+chr(10)

 
   if instr(mychaine,"#if C") > 0 then  
     mychaine = replace(mychaine,av,ap+av)
   else
      logaddline("no tag <#if C> ***error***")  
   end if  
end sub

'================================================== 
sub addprogmemT(ts)
logaddline("addprogmem text") 
   dim a, i, j, ap, av, str_t, strx
   ap = "" : j = 0 

   str_t = "const char* const str"+cstr(fnb)+"_table{] PROGMEM = {"
   While Not ts.atEndOfStream
      a = ts.ReadLine
      if len(a) > flength then flength = len(a)
      ap = ap + "const char str"+cstr(fnb)+"_"+cstr(j)+"[] PROGMEM = "+chr(34) + a + chr(34)+";"+chr(10)
      if j = 0 then
        str_t = str_t + "str"+cstr(fnb)+"_"+cstr(j)
      else
        str_t = str_t + " ,str"+cstr(fnb)+"_"+cstr(j)
      end if  
      j=j+1 
   wend
   ts.close
   str_t = str_t + " };"+chr(10)                                                  
   logaddline("end text=> PROGMEM add")  
    'change length max of string in strx'  
    strx ="char strx["+cstr(flength)+"];"
'add strx 
    if instr(mychaine,"#include <avr/pgmspace.h>")>0 then
       mychaine=replace(mychaine,"#include <avr/pgmspace.h>","#include <avr/pgmspace.h>"+chr(10)+strx)
    else
       logaddline("no tag <#include <avr/pgmspace.h>> ***error***")
    end if   
'add progmem code'   
   av = "B4R::Object beo1;"+chr(10)
   if instr(mychaine,"B4R::Object beo1;")>0 then  
     mychaine = replace(mychaine,av,ap +chr(10) + str_t + chr(10)+av)
   else
     logaddline(" no tag <B4R::Object beo1;> ***error***")
   end if    

'add P_buff'
   mychaine = replace(mychaine,"Sub Process_Globals","Sub Process_Globals"+chr(10)+ "    Public P_buff() As Byte" )
end sub

 '==================================================' 
sub checkPROGMEMT
 logaddline("checkPROGMEM text")
 ' check if some getstring are created, to define the first availabel
   dim P_MEM, e_xist, i ,j
  err = 0
   if instr(mychaine,"const char str") < 1 then 
      fi = 0   'no PROGMEM in file at start'
      fnb=1
      logaddline("fi=0 => <Addition first text file> mode")
   else
      fi = 1   'PROGMEM still present in file'  
      logaddline("fi=1 => <Insertion next text file> mode")
      P_MEM = array("test","getstr1", "getstr2", "getstr3", "getstr4", "getstr5", "getstr6", "getstr7", "getstr8", "getstr9", "getstr10", "getstr11", "getstr12", "getstr13", "getstr14", "getstr15", "getstr16", "getstr17", "getstr18", "getstr19")
      e_xist = array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)

      for i = 1 to 19
           if instr(mychaine,P_MEM(i)) = 0 then  
             e_xist(i)=1 'stringname available
 ''            logaddline("string available =>"+cstr(i)+" 0")
           else
  ''           logaddline("string not available ="+cstr(i)+" 1")
           end if
      next
      fnb=0
      for i = 1 to 19
          if e_xist(i) = 1 then       'first available'
            logaddline("string selected ="+cstr(i))
            fnb=i
            i=20
          else
''            logaddline("string not selected =string"+ cstr(j) )
          end if 
      next
   end if
   if instr(mychaine,"#if C" )<1 then 
       logaddline("no tag <#if C> ***error***")
       err = 1
   end if 
'check B4R::Object beo1;'     
   if instr(mychaine,"B4R::Object beo1;")<1 then 
     logaddline("no tag <B4R::Object beo1;> ***error***")
     err = 1
   end if 
'check #end if 
   if instr(mychaine,"#end if" )<1 then 
     logaddline("no tag <#end if> ***error***")
     err = 1
   end if  
    
''   get old flength
  if instr(mychaine,"char strx[") > 0 then
    i = instr(mychaine,"char strx[") : j = mid(mychaine,i+10,10): logaddline("j="+j)
    i = instr(j,"]") : j= mid(j,1,i-1)  :logaddline( j)
    flength = cint(j) : logaddline("old flength ="+cstr(flength) )
  else
    flength = 0
  end if 
 end sub
 








 
'==================================================' 
'Gzip to PROGMEM in Static.bas file
'==================================================' 
' open a gzip file and add content in hexa format in PROGMEM part
' at start, a file Static.bas must be created and PROGMEM data will be added at this one
' data are created by data1, data2, data3, etc....'
' a commun GETBYTE sub is created/modified to handle all data files from B4R
' an object is created to handle each data file at arduino level'
sub progmemaddzip

   set obj1 = NewEditor()           'new editor object
   set obj2 = NewEditor()
   obj1.assignActiveEditor         'assign PSPad window active to obj1   
   obj2.NewFile()      
    mychaine = obj1.text
  
   mychaine = replace(mychaine,chr(13),"")
   mychaine = replace(mychaine,chr(09),"    ")
   '' myarray = split(mychaine,chr(10))
   'l_max = ubound(myarray)
 ''  chaine = ""
    fi = 0
    logclear
    checkPROGMEM : if err = 1 then exit sub
   logaddline(fi)
   Const ForReading = 1, ForWriting = 2, ForAppending = 8
   Dim fso, wshshell, strCurDir, f  ,l_array, l_chain1,l_chain2,l_max ,l_pos1,l_pos2 , l_p1,ts ,a , i ,j
   dim s_IniDir, s_Filter,chaine , path   
 
   s_IniDir = replace("D:\B4R\B4R_applis\testaWOT\gzip"+"\*","\","\\")       
   s_Filter = "gzip file (*.gz)"

   path = replace(GetFileDlg(s_IniDir,s_Filter,"Select gzip file to add in PROGMEM"),chr(13)+chr(10),"")
   if path ="" then exit sub
   Set fso = CreateObject("Scripting.FileSystemObject")
   Set f = fso.getFile(path)
   Set ts = f.OpenAsTextStream()
   logaddline("file size:"+ cstr(f.size))
   i=0:j=0 : fname =  fso.getfilename(path)
   logaddline(fname)
   'before PROGMEM, we add header  and existing file in start file   
    
   if fi=0 then 
      addprogmem(ts) 
      addheader 
      addfooter
   else
      insertprogmem(ts)    
      insertheader
      insertfooter
   end if  
   
 ' after PROGMEM added
 
 obj2.text (mychaine)
 end sub
 
 '================================================== 
sub insertprogmem(ts) 
logaddline("insertprogmem gzip")
   dim a, i, j,av,ap
   av = "B4R::Object beo1;"+chr(10)
   ap = ap + "const PROGMEM Byte data"+cstr(fnb)+"[] = {       //filename:"+fname+ chr(10) +"    "
   While Not ts.atEndOfStream
      a = asc(ts.read(1))
      ap = ap + "0x"+ right("0"+hex(a),2)
      i=i+1 :j=j+1
      if not(ts.atEndOfStream) then ap = ap + ", " : '

      if i = 16 then 
        ap = ap + chr(10)+"    "
        i = 0
''        logaddline("end line")
      end if  
   Wend
   ap = ap +chr(10)+ "    };  //length="+cstr(j)+chr(10) +chr(10)
  ts.close
  flength = j

   if instrrev(mychaine,"B4R::Object beo1;")> 0 then 
       mychaine = replace(mychaine,av,ap+av)
       logaddline("footer added")
   else
      logaddline("tag <B4R::Object beo1;> not found ***error*** ")  
   end if 


end sub
 
'================================================== 
sub addprogmem(ts) 
logaddline("addprogmem gzip")
   dim a, i, j, av, ap
   ap =  "const PROGMEM Byte data"+cstr(fnb)+"[] = {       //filename:"+fname+ chr(10) +"    "    
   While Not ts.atEndOfStream
      a = asc(ts.read(1))  
      ap = ap + "0x"+ right("0"+hex(a),2)
      i=i+1 :j=j+1
      if not(ts.atEndOfStream) then ap = ap + ", " : '

      if i = 16 then 
        ap = ap + chr(10)+"    "
        i = 0                                                                    
''        logaddline("end line")
      end if  
   Wend
   ts.close 
   ap = ap + chr(10)+"    };  //length="+cstr(j)+chr(10) +chr(10)
   av = "B4R::Object beo1;"+chr(10) 
   
   if instr(mychaine,"B4R::Object beo1;")>0 then
     mychaine = replace(mychaine,av,ap + av)
   else
     logaddline("tag <B4R::Object beo1;> not found ***error****")
   end if  
   flength = j
  end sub
 '=================================================
 sub insertfooter
 logaddline("insertfooter gzip")
   dim av, ap
   av = "#end if"+chr(10)
   ap =  "  B4R::Object* getdata"+cstr(fnb)+"(B4R::Object* o) { "+chr(10)
   ap = ap + "    return beo1.wrapNumber(pgm_read_byte_near(data"+ cstr(fnb)+" + o->toLong()));"+chr(10)
   ap = ap + "  }"+chr(10)
   ap = ap + "#end if"+chr(10)   
   
   if instrrev(mychaine,av)> 0 then 
     mychaine = replace(mychaine,av,ap)
     logaddline("footer added")
   else
     logaddline("tag<#end if> not found => footer not added")  
    end if 
 end sub
 
'================================================== 
 sub insertheader
 logaddline("insertheader gzip")
   dim i, av, ap, chain, getbyte, getlength  
 'case getbyte'   
   av ="    Case Else"
   ap = "    Case "+cstr(fnb)+chr(10)
   ap = ap + "      Return RunNative(""getdata"+cstr(fnb)+" "", Index)"+chr(10)    
   
   myarray = split(mychaine,chr(10))
   l_max = ubound(myarray)                               
   for i = 0 to l_max
     if instr(myarray(i),"Public Sub GetByte")> 0 then getbyte = 1
     if instr(myarray(i),"Case Else")> 0 and getbyte = 1 then
        myarray(i) = ap + av
        getbyte = 0
        exit for
     end if
   next
   if i >= l_max then logaddline("no tag <    case else> => ***error***")         
   mychaine = join(myarray,chr(10))
   
'case getlength'   
   ap = "    Case "+cstr(fnb)+chr(10)
   ap = ap + "      Return "+cstr(flength)++chr(10)
   av ="    Case Else" 
   myarray = split(mychaine,chr(10))
   l_max = ubound(myarray)   
   for i = 0 to l_max
     if instr(myarray(i),"Public Sub Getlength")> 0 then getlength = 1
     if instr(myarray(i),"Case Else")> 0 and getlength = 1 then
        myarray(i) = ap + av
        getlength = 0
        exit for
     end if
   next 
   if i >=l_max then logaddline("tag <    case else> not found ***error***")        
   mychaine = join(myarray,chr(10)) 
  
 end sub
'==================================================' 
 sub addfooter 
  logaddline("addfooter gzip")
' after PROGMEM  
  dim av, ap
  ap = "  B4R::Object* getdata"+cstr(fnb)+"(B4R::Object* o) { "+chr(10)
  ap = ap + "    return beo1.wrapNumber(pgm_read_byte_near(data"+cstr(fnb)+" + o->toLong()));"+chr(10)
  ap = ap + "  }"+chr(10)

  av = "#end if"+chr(10)
  if instr(mychaine,"#end if") > 0 then
     mychaine = replace(mychaine,av,ap+av)
  else   
     logaddline("no tag <#end if> =>***error***")
  end if   
end sub

'=================================================='  
sub addheader
 logaddline("addheader gzip")
'before PROGMEM
   dim av, ap, ap2
   av= "#if C"+chr(10)

   ap =      "Public Sub GetByte(table As Byte,Index As UInt) As Byte"+chr(10)
   ap = ap + "  Select table"+chr(10)
   ap = ap + "    Case 1"+chr(10)
   ap = ap + "      Return RunNative(""getdata"+cstr(fnb)+" "", Index)"+chr(10)
   ap = ap + "    Case Else" +chr(10)
   ap = ap + "      Return 0"+chr(10)
   ap = ap + "  End Select" +chr(10)  
   ap = ap + "End Sub"+chr(10)+chr(10)
   ap = ap + "Public Sub Getlength(table as Byte) As UInt"+chr(10)
   ap = ap + "  Select table "+chr(10)
   ap = ap + "    Case 1 "+chr(10)
   ap = ap + "      Return "+cstr(flength)++chr(10)
   ap = ap + "    Case Else" +chr(10)   
   ap = ap + "      Return 0"+chr(10)
   ap = ap + "  End Select" +chr(10)  
   ap = ap + "End Sub"+chr(10)+chr(10)
      
   if instr(mychaine,"#if C")>0 then 
     mychaine = replace(mychaine,av,ap+av)
   else
     logaddline("no tag <#if C> => ***error***")  
   end if  
end sub
 
 '==================================================' 
sub checkPROGMEM
  logaddline("checkprogmem gzip")
   dim P_MEM, e_xist, i ,j
   err = 0
   if instr(mychaine,"const PROGMEM Byte data") < 1 then 
      fi = 0   'no PROGMEM in file at start'
      fnb=1
      logaddline("fi=0 => <Addition first gzip> mode")
   else
      fi = 1   'PROGMEM still present in file'  
      logaddline("fi=1 => <insertion next gzip> mode")
      P_MEM = array("test","getdata1", "getdata2", "getdata3", "getdata4", "getdata5", "getdata6", "getdata7", "getdata8", "getdata9", "getdata10", "getdata11", "getdata12", "getdata13", "getdata14", "getdata15", "getdata16", "getdata17", "getdata18", "getdata19")
      e_xist = array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)

      for i = 1 to 19
           if instr(mychaine,P_MEM(i)) = 0 then  
             e_xist(i)=1 'dataname available
 ''            logaddline("data available =>"+cstr(i)+" 0")
           else
  ''           logaddline("data not available ="+cstr(i)+" 1")
           end if
      next
      fnb=0
      for i = 1 to 19
          if e_xist(i) = 1 then       'first available'
            logaddline("data selected ="+cstr(i))
            fnb=i
            i=20
          else
''            logaddline("data not selected =data"+ cstr(j) )
          end if 
      next
 'check #if C  
   end if
   if instr(mychaine,"#if C" )<1 then 
       logaddline("no tag <#if C> ***error***")
       err = 1
   end if 
'check B4R::Object beo1;'     
   if instr(mychaine,"B4R::Object beo1;")<1 then 
     logaddline("no tag <B4R::Object beo1;> ***error***")
     err = 1
   end if 
'check #end if 
   if instr(mychaine,"#end if" )<1 then 
     logaddline("no tag <#end if> ***error***")
     err = 1
   end if  
 end sub

'==================================================' 
sub static_basCreate
 logaddline("static base create")
'create a file Static.bas file empty and ready to add PROGMEM after'
   set obj1 = NewEditor()           'new editor object 
   obj1.NewFile("P.bas")      
    mychaine ="B4R=true"+chr(10)
    mychaine = mychaine +"Group=Default Group"+chr(10)
    mychaine = mychaine +"ModulesStructureVersion=1"+chr(10)
    mychaine = mychaine +"Type=StaticCode"+chr(10)
    mychaine = mychaine +"Version=3.9"+chr(10)
    mychaine = mychaine +"@EndOfDesignText@"+chr(10)+chr(10)+chr(10)
    mychaine = mychaine +"Sub Process_Globals"+chr(10)
	mychaine = mychaine +"    'These global variables will be declared once when the application starts."+chr(10)
	mychaine = mychaine +"    'Public variables can be accessed from all modules."+chr(10)+chr(10)	
    mychaine = mychaine +"End Sub"+chr(10) +chr(10)
    mychaine = mychaine + "#if C"+chr(10)
    mychaine = mychaine + "#include <avr/pgmspace.h>"+chr(10)+chr(10)
    mychaine = mychaine + "B4R::Object beo1;"+chr(10) +chr(10)
    mychaine = mychaine + "#end if"+chr(10)

    obj1.text(mychaine)
end sub


'==================================================' 
Function GetFileDlg(sIniDir,sFilter,sTitle)
    	GetFileDlg=CreateObject("WScript.Shell").Exec("mshta.exe ""about:<object id=d classid=clsid:3050f4e1-98b5-11cf-bb82-00aa00bdce0b></object><script>moveTo(0,-9999);function window.onload(){var p=/[^\0]*/;new ActiveXObject('Scripting.FileSystemObject').GetStandardStream(1).Write(p.exec(d.object.openfiledlg('" & sIniDir & "',null,'" & sFilter & "','" & sTitle & "')));close();}</script><hta:application showintaskbar=no />""").StdOut.ReadAll
End Function
'==================================================' 
'edition du scrip
'================================================== 
  sub openScript1
   set obj1 = newEditor()
   obj1.openFile(moduleFileName("B4R_PROGMEM") )
 end sub
 
'==================================================' 
'init menu
'==================================================' 
' name "Init" is required, its called automatically during initialization to create menu items
sub Init
  addMenuItem "0-PROGMEM Create"                     ,"B4R"   , "progmemCreate"
  addMenuItem "1-PROGMEM Remove"                     ,"B4R"   , "progmemRemove"  
  addMenuItem "2-PROGMEM => Extract TXT"             ,"B4R"   , "progmemExtraxt"  
  addMenuItem "3 --------------------"               ,"B4R"   , "rien"  
  addMenuItem "4-Create Static.bas"                  ,"B4R"   , "static_basCreate"    
  addMenuItem "5-gzip => Static.bas "                ,"B4R"   , "progmemaddzip"  
  addMenuItem "6-txt => Static.bas"                  ,"B4R"   , "progmemaddtxt"     
  addMenuItem "7-Edit script"                        ,"B4R"   , "openScript1"     
  addMenuItem "8 --------------------"               ,"B4R"   , "rien"   

end sub 
